--- /usr/local/lib/python2.7/dist-packages/pyinotify-0.9.2-py2.7.egg/pyinotify.py	2011-06-23 18:42:09.454180680 +0300
+++ /usr/local/lib/python2.7/dist-packages/pyinotify-0.9.2-py2.7.egg/pyinotify.py.new	2011-06-22 02:35:41.565601732 +0300
@@ -1729,6 +1729,7 @@
         """
         self._exclude_filter = exclude_filter
         self._wmd = {}  # watch dict key: watch descriptor, value: watch
+        self._wmdp = {}  # watch dict key: watch path, value: watch descriptor
 
         self._inotify_wrapper = INotifyWrapper.create()
         if self._inotify_wrapper is None:
@@ -1778,6 +1779,10 @@
         """
         try:
             del self._wmd[wd]
+            for key, val in self._wmdp.iteritems():
+                if val == wd:
+                    del self._wmdp[key]
+                    break
         except KeyError, err:
             log.error(str(err))
 
@@ -1816,6 +1821,7 @@
         watch = Watch(wd=wd, path=path, mask=mask, proc_fun=proc_fun,
                       auto_add=auto_add, exclude_filter=exclude_filter)
         self._wmd[wd] = watch
+        self._wmdp[path] = wd
         log.debug('New %s', watch)
         return wd
 
@@ -2040,9 +2046,8 @@
         @rtype: int or None
         """
         path = self.__format_path(path)
-        for iwd in self._wmd.items():
-            if iwd[1].path == path:
-                return iwd[0]
+        if path in self._wmdp:
+            return self._wmdp[path]
 
     def get_path(self, wd):
         """
@@ -2113,6 +2118,11 @@
             # Remove watch from our dictionary
             if awd in self._wmd:
                 del self._wmd[awd]
+                for key, val in self._wmdp.iteritems():
+                    if val == awd:
+                        del self._wmdp[key]
+                        break
+
             ret_[awd] = True
             log.debug('Watch WD=%d (%s) removed', awd, self.get_path(awd))
         return ret_
